from wxPython.wx import *
from wxPython.grid import *
import os, shutil, sys
import osnovnaHTMLObrada

class GlavniProzor(wxFrame):
	""" Nasledjuje se klasa Frame """
	
	ID_OTVORI = 201
	ID_OBRISI_VEZU = 203
	ID_NOV = 204
	ID_NOVA_VEZA = 205
	ID_SACUVAJ = 206
	ID_PUTANJA = 301
	
	def __init__(self, otac, id, naslov):
		self.naslov = naslov
		self.tekFajl = ''
		self.izmenjeno = False
		self.parser = None
		
		wxFrame.__init__(self, otac, -4, self.naslov, size =  wxSize(550,500),
						 style = wxDEFAULT_FRAME_STYLE | wxNO_FULL_REPAINT_ON_RESIZE)
		
		stub = wxBoxSizer(wxVERTICAL)
		
		red1 = wxBoxSizer(wxHORIZONTAL)
		red2 = wxBoxSizer(wxHORIZONTAL)
		
		red1.Add(wxStaticText(self, 110011, 'Izvor: '))
		self.putanja = wxTextCtrl(self, GlavniProzor.ID_PUTANJA, style = wxTE_READONLY, size = (280, 20))
		red1.Add(self.putanja)
		nov = wxButton(self, GlavniProzor.ID_NOV, 'Nov')
		red1.Add(nov)
		
		otvori = wxButton(self, GlavniProzor.ID_OTVORI, 'Otvori')
		red1.Add(otvori)
		
		sacuvaj = wxButton(self, GlavniProzor.ID_SACUVAJ, 'Sauvaj')
		red1.Add(sacuvaj)
		
		novaVeza = wxButton(self, GlavniProzor.ID_NOVA_VEZA, 'Nova veza')
		red2.Add(novaVeza)
		
		obrisi = wxButton(self, GlavniProzor.ID_OBRISI_VEZU, 'Obrii vezu')
		red2.Add(obrisi)
		
		stub.Add(red1)
		stub.Add(red2)
		
		EVT_BUTTON(self, GlavniProzor.ID_OTVORI, self.naOtvori)
		EVT_BUTTON(self, GlavniProzor.ID_NOV, self.naNovi)
		EVT_BUTTON(self, GlavniProzor.ID_OBRISI_VEZU, self.naObrisiVezu)
		EVT_BUTTON(self, GlavniProzor.ID_NOVA_VEZA, self.naNovaVeza)
		EVT_BUTTON(self, GlavniProzor.ID_SACUVAJ, self.naSacuvaj)
		EVT_CLOSE(self, self.naZatvaranjuProzora)
		
		self.mreza = MojaMrezica(self)
		
		stub.Add(self.mreza, 11, wxEXPAND)
		self.SetSizer(stub)
		
		self.SetAutoLayout(True)
		
	def naNovi(self, e):
		# Stvara novi prazan dokument. To radi tako to se isparsira prazan ablon kome
		# se prethodno postave ispravne putanje za sliice koje sadri i to se radi samo
		# ako za tim ima potrebe.
		print '\n@naNovi: Begin'#
		pomF = sys.path[0]+'/'+'izmenjensablon'
		if not self.sacuvajAkoJePotrebno(e): # pritisnuto CANCEL na pitanje "elite li da sauvati promene?" pa se odustaje od ove metode ili nije izvrena metoda naSacuvaj
			return
		if not os.path.exists(pomF):
			self.osveziPutanjeSlicica(pomF) # izvrsava se samo prvi put
		self.isparsiraj(pomF)
		# print '!isparsirano!'#
		self.tekFajl = ''
		self.SetTitle(self.naslov + ' - ' + 'nepostoje_fajl')
		self.putanja.SetValue('Dokument nije sauvan - fajl ne postoji')
		self.objaviIzmenu()
		self.osveziPrikaz()
		print '@naNovi: End'#
		
	def naZatvaranjuProzora(self, evt):
		# Izvrava se automatski pri zatvaranju programa i slui da ne dozvoli
		# izlazak iz programa ako dokument nije sauvan, osim ako se izriito ne naredi
		if not self.sacuvajAkoJePotrebno(evt): # pritisnuto CANCEL na pitanje "elite li da sauvati promene?" pa se odustaje od ove metode ili nije izvrena metoda naSacuvaj
			return
		self.Destroy()
		
	
	def naSacuvaj(self, e):
		# Tekui dokument upisjuje u fajl. Ako tekui dokument nije pridruen nekom fajlu
		# (napravljen je sa Novi) otvara se dijalog za uzimanje imena novog fajla
		if not self.parser:
			cDlg = wxMessageDialog(self, 'Morate otvoriti postojei dokument ili stvoriti novi', "Nemogue je sauvati dokument koji ne postoji", style = wxID_OK)
			try:
				cDlg.ShowModal()
			finally:
				cDlg.Destroy()
			return False
		if not self.izmenjeno: # nema ta da se sauva
			return False
		
		if not self.tekFajl:
			sDlg = wxFileDialog(self, "Nov fajl", '' , "index.html",
					"HTML fajlovi (*.html; *.htm)|*.htm;*.html", style = wxSAVE | wxOVERWRITE_PROMPT)
			try:
				if sDlg.ShowModal() == wxID_OK:
					self.tekFajl = sDlg.GetPath()
				else:
					return False
			finally:
				sDlg.Destroy()
		try:
			izlaz = file(self.tekFajl, 'wb')
			try:
				izlaz.write( self.parser.output() )
				self.SetTitle(self.naslov + ' - ' + self.tekFajl)
				self.putanja.SetValue(self.tekFajl)
				self.izmenjeno = False
				return True
			finally:
				izlaz.close()
		except IOError:
			print >> sys.stderr, "Greska u fajlu:", self.tekFajl
			sys.exit(1)
			
	def naNovaVeza(self, e):
		# Stvara novu vezu u dokumentu. Prvo se pomou dijaloga dobije putanja na fajl na koji
		# e veza pokazivati, a potom i ime te veze. Posle se na osnovu tih podataka stvara
		# objekat klase Veza koji se ubacuje u listu parser.veze i na osnovu te liste se
		# ponovo ispisuje promenjena mrea
		if not self.parser:
			cDlg = wxMessageDialog(self, 'Morate otvoriti postojei dokument ili stvoriti novi', "Nemogue je napraviti vezu", style = wxID_OK)
			try:
				cDlg.ShowModal()
			finally:
				cDlg.Destroy()
			return
			
		oDlg = wxFileDialog(self, "Odaberi fajl metu", "", "",
				'HTML fajlovi (*.html; *.htm)|*.htm;*.html|PDF fajlovi (*.pdf)|*.pdf|PS fajlovi (*.ps)|*.ps|svi fajlovi (*.*)|*.*', 
				style = wxOPEN | wxFILE_MUST_EXIST)
		try:
			if oDlg.ShowModal() == wxID_OK:
				imefajla = oDlg.GetPath()
			else:
				return
		finally:
			oDlg.Destroy()
			
		tDlg = wxTextEntryDialog(self, 'Ime veze:', caption = 'Unesti ime veze', style = wxOK | wxCENTRE)#wxCENTRE)#wxOK)# | wxCANCEL )
		
		try:
			if tDlg.ShowModal() == wxID_OK:
				ime = tDlg.GetValue()
				if ime.strip():
					self.parser.veze.append( osnovnaHTMLObrada.Veza(imefajla, ime) )
					self.osveziPrikaz()
					self.objaviIzmenu()
		finally:
			tDlg.Destroy()
		
	def naOtvori(self, e):
		# Otvara fajl koji se odabira dijalogom, potom ga parsira i rezultat ispisuje u mreu
		if not self.sacuvajAkoJePotrebno(e): # pritisnuto CANCEL na pitanje "elite li da sauvati promene?" pa se odustaje od ove metode ili nije izvrena metoda naSacuvaj
			return
		
		oDlg = wxFileDialog(self, "Odaberi fajl", "", "",
				'HTML fajlovi (*.html; *.htm)|*html;*.htm', style = wxOPEN | wxFILE_MUST_EXIST)
		try:
			if oDlg.ShowModal() == wxID_OK:
				self.tekFajl = oDlg.GetPath()
				self.isparsiraj(self.tekFajl)
				self.osveziPrikaz()
				self.izmenjeno = False
				self.SetTitle(self.naslov + ' - ' + self.tekFajl)
				self.putanja.SetValue(self.tekFajl)
		finally:
			oDlg.Destroy()
			
	def naObrisiVezu(self, e):
		# Brie odgovarajui lan liste parser.veze na osnovu reda koji je odabran u mreici
		# (tabeli) i na osnovu tog novog stanja liste ispisuje se mreica.
		if not self.parser:
			cDlg = wxMessageDialog(self, 'Morate otvoriti postojei dokument ili stvoriti novi', "Brisanje je nemogue", style = wxID_OK)
			try:
				cDlg.ShowModal()
			finally:
				cDlg.Destroy()
			return
			
		poruka = "elite li da trajno obriete vezu: " \
				+ self.parser.veze[self.mreza.red].dajIme()
				
		cDlg = wxMessageDialog(self, poruka, "Upozorenje", style = wxYES_NO)
		
		try:
			if cDlg.ShowModal() == wxID_YES:
				del self.parser.veze[self.mreza.red]
				self.osveziPrikaz()
				self.objaviIzmenu()
		finally:
			cDlg.Destroy()
			
	def osveziPrikaz(self):
		# Brie sve redove u mrei (tabeli), zatim doda redova koliko je lista parser.veze
		# duga i na kraju ih popuni sa podacima iz objekata klase Veza koji se nalaze u toj listi
		print '@osveziPrikaz: Begin'#
		br = self.mreza.GetNumberRows()
		if br: 							# ako br nije nula
			print 'na DeleteNumberRows()'#
			self.mreza.DeleteRows(0, br)
			print 'posle DeleteNumberRows()'#
			
		self.mreza.AppendRows(len(self.parser.veze))
		self.parser.veze.sort()
		i = 0
		for e in self.parser.veze:
			self.mreza.SetCellValue(i, 0, e.dajIme())
			self.mreza.SetCellValue(i, 1, e.dajVezu())
			i += 1
			
		self.mreza.AutoSizeColumns()
		print '@osveziPrikaz: End'#
		
	def izmeniImeVeze(self, ime, indeks):
		# Poziva se na izmenu poja mree u kome se nalazi ime veze. Novo ime se daje
		# odgovarajuem objektu niza parser.veze
		print '@izmeniImeVeze: Begin'#
		try:
			self.parser.veze[indeks].staviIme(ime)
			self.osveziPrikaz()
			self.objaviIzmenu()
		except IndexError:
			print '\n ********ERROR code begin***********\n'
			print '* indeks je:', indeks
			print '* veze su:'
			j = 0
			for i in self.parser.veze:
				print '*veza[%d] je: %s *' % (j, i.dajIme())
				j += 1
			print '\n ********ERROR code end***********\n'
		print '@izmeniImeVeze: End'#
		
	def objaviIzmenu(self):
		# Menja naslov prozora dodajui '*' na kraj naziva oznaavajui da je dokument promnjen,
		# a da nije sauvan. Takoe se i atribut izmenjeno postavlja na True.
		print '@objaviIzmenu: Begin'#
		naslov = self.GetTitle()
		if not naslov.endswith('*'):
			self.SetTitle(naslov + '*')
		self.izmenjeno = True
		print '@objaviIzmenu: End'#
		
	def osveziPutanjeSlicica(self, imeFajla):
		# U originalni obrazac se stavljaju odgovarajue putanje do sliica i tako izmenjeni
		# obrazac se uva u novom fajlu za kasniju upotrebu.
		try:
			ulaz = file(sys.path[0]+'/'+'sablon', 'rb')
			try:
				txt = ulaz.read()
			finally:
				ulaz.close()
		except IOError:
			print >> sys.stderr, "Greska u citanju fajla:", sys.path[0]+'/'+'sablon'
			sys.exit(1)
		txt = txt.replace('fade.gif', sys.path[0]+'/'+'fade.gif')
		txt = txt.replace('backblue.gif', sys.path[0]+'/'+'backblue.gif')
		try:
			izlaz = file(imeFajla, 'wb')
			try:
				izlaz.write(txt)
			finally:
				izlaz.close()
		except IOError:
			print >> sys.stderr, "Greska u pisanju fajla:", imeFajla
			sys.exit(1)
			
	def sacuvajAkoJePotrebno(self, e):
		# Ako je dokument promenjen a nij esauvan tada se pojavljuje dijalog koji nam omoguava
		# da promene sauvamo, da ih ne sauvamo i da otkaemo dajli rad.
		print '@sacuvajAkoJePotrebno: Begin'#
		if self.izmenjeno:
			print 'message dialog'#
			cDlg = wxMessageDialog(self, "elite li da sauvati promene?", 'Dokument nije sauvan', style = wxYES_NO | wxCANCEL)
			try:
				odgovor = cDlg.ShowModal()
				
				if odgovor == wxID_CANCEL:
					print '@sacuvajAkoJePotrebno: End'#
					return False # False znai da sacuvajAkoJePotrebno nije odradila posao
				if odgovor == wxID_YES:
					if not self.naSacuvaj(e):
						print '@sacuvajAkoJePotrebno: End'#
						return False
			finally:
				cDlg.Destroy()
		print '@sacuvajAkoJePotrebno: End'#
		return True
		
	def isparsiraj(self, imefajla):
		# Uitava fajl ija je putanja prosleena kao imefajla i zatim ga parsira.
		try:
			ulazniF = file(imefajla, "rb")
			try:
				htmlKod = ulazniF.read()
			finally:
				ulazniF.close()
		except IOError:
			print >> sys.stderr, "Greska u citanju. Ne postoji fajl:", imefajla
			sys.exit(1)
			
		self.parser = osnovnaHTMLObrada.OsnovnaHTMLObrada()
		self.parser.feed(htmlKod)
		self.parser.close()
		
#---------------------------------------------------------------------------

class MojaMrezica(wxGrid):
	""" Nasleuje klasu wxGrid """
	def __init__(self, parent):
		wxGrid.__init__(self, parent, -1)
		self.otac = parent
		self.red = 0
		
		self.CreateGrid(0, 2)
		
		self.SetColLabelAlignment(wxALIGN_LEFT, wxALIGN_BOTTOM)
		self.SetColLabelValue(0, "Naziv knjige")
		self.SetColLabelValue(1, "putanja")
		self.SetRowLabelSize(20)
		self.AutoSizeColumns()
		
		attr = wxGridCellAttr()
		attr.SetTextColour(wxBLACK)
		attr.SetBackgroundColour(wxLIGHT_GREY)
		attr.SetFont(wxFont(9, wxSWISS, wxNORMAL, wxNORMAL))
		self.SetColAttr(1, attr)
		
		EVT_GRID_CELL_CHANGE(self, self.naPromenuPolja)
		EVT_GRID_SELECT_CELL(self, self.naOdabirPolja)
		
	def naPromenuPolja(self, evt):
		# Uzima novo ime veze iz mree i alje ga metodi izmeniImeVeze klase GlavniProzor
		print '@naPromenuPolja: Begin' #
		red = evt.GetRow()
		novoIme = self.GetCellValue(red, 0)
		
		if novoIme.strip():
			novoIme = novoIme.capitalize()
			self.SetCellValue(red, 0, novoIme)
			self.otac.izmeniImeVeze(novoIme, red)
		print '@naPromenuPolja: End' #
		
	def naOdabirPolja(self, evt):
		# Pamti red tekueg odabranog polja mreice u atribut red. Proverava da li
		# u prethodnom polju ima ieg zapisanog. Ako nema tada se prekida odabir 
		# polja to znai da se fokus vraa na polje u koje nismo nta upisali 
		print '@naOdabirPolja (%d): Begin' % (evt.GetRow())#
		self.red = evt.GetRow()
		prethodniRed = self.GetGridCursorRow()
		
		if self.IsCellEditControlEnabled():
			self.HideCellEditControl()
			self.DisableCellEditControl()
		if prethodniRed != -1:
			vrednost = self.GetCellValue(prethodniRed, 0)
			if not vrednost.strip():
				return  # prekida odabir polja
		evt.Skip()
		print '@naOdabirPolja: End'#
		
#---------------------------------------------------------------------------

if __name__ == "__main__":
	app = wxPySimpleApp()
	okvir = GlavniProzor(None, -1, "Bibliotekar")
	okvir.Show(True)
	app.MainLoop()
